# model.py

from sqlalchemy import Table, Column, create_engine
from sqlalchemy import Integer, ForeignKey, Unicode
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import backref, relation

engine = create_engine("sqlite:///devdata.db", echo=True)
DeclarativeBase = declarative_base(engine)
metadata = DeclarativeBase.metadata

########################################################################
class Person(DeclarativeBase):
    """"""
    __tablename__ = "person"
    
    id = Column(Integer, primary_key=True)
    first_name = Column(Unicode(50))
    last_name = Column(Unicode(50))
        
    #----------------------------------------------------------------------
    def __repr__(self):
        """"""
        return "<Person: %s %s>" % (self.first_name, self.last_name)
    

########################################################################
class Book(DeclarativeBase):
    """"""
    __tablename__ = "book"
    
    id = Column(Integer, primary_key=True)
    author_id = Column(Integer, ForeignKey("person.id"))
    title = Column(Unicode)
    isbn = Column(Unicode)
    publisher = Column(Unicode)
    person = relation("Person", backref="books", cascade_backrefs=False)
    
    @property
    def author(self):
        return "%s %s" % (self.person.first_name, self.person.last_name)
        